package com.perforce.spark.artifact;

import java.util.ArrayList;
import java.util.List;

import com.perforce.p4java.core.IDepot.DepotType;

public enum ArtifactType {

	// Specialisation
	MAVEN("Maven Artifact"),
	LOCAL("Generic Artifact"),
	GEM("RubyGem Artifact"),

	// undefined/unknown
	UNKNOWN("Unknown Artifact");

	private final String title;

	ArtifactType(String title) {
		this.title = title;
	}

	public static ArtifactType parse(String value) {
		for (ArtifactType type : ArtifactType.values()) {
			if (type.name().equalsIgnoreCase(value)) {
				return type;
			}
		}
		return UNKNOWN;
	}

	public static ArtifactType parse(DepotType type) {
		return parse(type.name());
	}

	public static List<ArtifactType> list() {
		List<ArtifactType> list = new ArrayList<>();
		for (ArtifactType type : ArtifactType.values()) {
			if (!type.equals(UNKNOWN)) {
				list.add(type);
			}
		}
		return list;
	}

	public String getId() {
		return this.name().toLowerCase();
	}

	public String getTitle() {
		return title;
	}
}
