package com.perforce.spark.site;

import java.util.ArrayList;
import java.util.List;

public enum SiteType {

	STORE("Artifact Repo"), 
	GROUP("Artifact Group"),
	PROXY("Proxy Site"), 
	MIRROR("Mirror Site"), 
	UNKNOWN("Unknown Site");

	private final String title;

	SiteType(String title) {
		this.title = title;
	}

	public static SiteType parse(String value) {
		for (SiteType type : SiteType.values()) {
			if (value.equalsIgnoreCase(type.name())) {
				return type;
			}
		}
		return UNKNOWN;
	}

	public static List<SiteType> list() {
		List<SiteType> list = new ArrayList<>();
		for (SiteType type : SiteType.values()) {
			if (!type.equals(UNKNOWN)) {
				list.add(type);
			}
		}
		return list;
	}

	public String getId() {
		return this.name().toLowerCase();
	}

	public String getTitle() {
		return title;
	}
}
